/*
    This file is part of SourcePawn SteamWorks.

    SourcePawn SteamWorks is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, as per version 3 of the License.

    SourcePawn SteamWorks is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with SourcePawn SteamWorks.  If not, see <http://www.gnu.org/licenses/>.
	
	Author: Kyle Sanderson (KyleS).
*/

#ifdef _INCLUDE_METAMOD_SOURCE_CEF
#endinput
#endif

#define _INCLUDE_METAMOD_SOURCE_CEF

#include <ISmmPlugin.h>
#include "engine_wrappers.h"
#include <playerinfomanager.h>

#include <eiface.h>
#include <inetchannel.h>

#include <unistd.h>
#include <signal.h>

extern ICvar *icvar;

class Cassandra : 
	public ISmmPlugin
{
public:
	bool Load(PluginId id, ISmmAPI *ismm, char *error, size_t maxlen, bool late);
	bool Unload(char *error, size_t maxlen);

public:
	const char *GetAuthor();
	const char *GetName();
	const char *GetDescription();
	const char *GetURL();
	const char *GetLicense();
	const char *GetVersion();
	const char *GetDate();
	const char *GetLogTag();
public:
	bool LevelInit(char const *pMapName, char const *pMapEntities, char const *pOldLevel, char const *pLandmarkName, bool loadGame, bool background);
	void OnGameFrame(bool simulating);
public:
	void InstallSignalHandler(void);
	void RemoveSignalHandler(void);
	void Hooped(void);
	void TakeStackTrace(const char *pInput);
private:
	int m_iGameFrameHook;
	int m_iLevelInitHook;
	unsigned m_iCounter;
};

PLUGIN_GLOBALVARS();

void SignalAction(int sig, siginfo_t *pInfo, void *pData);
int RecvFrom(int s, char *buf, int len, int flags, struct sockaddr *from, int *fromlen);
